const { ccclass, property } = cc._decorator;

@ccclass
export default class Main extends cc.Component {
    /**
     *Socket 
    */
    private _socket: WebSocket;

    onLoad() {
    }

    protected start(): void {
        let uiCanvas: cc.Node = cc.find("Canvas");
        let btn1: cc.Button = uiCanvas.getChildByName("Btn1").getComponent<cc.Button>(cc.Button);
        btn1.node.on("click", this.onConnect.bind(this));
    }

    /**
     *执行Socket连接 
    */
    public onConnect(): void {
        console.log(">-执行Socket连接1");
        this._socket = new WebSocket("ws://192.168.2.199:7000");
        this._socket.binaryType = "arraybuffer";
        this._socket.onmessage = this.onMessage.bind(this);
        this._socket.onerror = this.onError.bind(this);
        this._socket.onclose = this.onClose.bind(this);
        this._socket.onopen = this.onOpen.bind(this);
        console.log(">-执行Socket连接2");
    }

    /**
     *Socket连接成功
     */
    private onOpen(evt): void {
        console.log(">-WebSocket onOpen");
    }

    /**
     *Socket连接错误
     */
    private onError(evt): void {
        console.log(">-WebSocket onError");
    }

    /**
     *Socket连接关闭
     */
    private onClose(evt): void {
        console.log(">-WebSocket onClose");
    }

    /**
     * 收到数据
     */
    private onMessage(evt): void {
        console.log(">-WebSocket onMessage byteLength:" + evt.data.byteLength);
    }
}
